# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Data(BaseModel):
    """
    Data
    """ # noqa: E501
    id: StrictStr = Field(alias="_id")
    key_in_provider: StrictStr
    provider_id: StrictStr
    friendly_name: StrictStr
    submitted_usernames: Optional[List[StrictStr]] = None
    relationships: Optional[List[StrictStr]] = None
    access: StrictStr
    create_ts: datetime
    modify_ts: datetime
    __properties: ClassVar[List[str]] = ["_id", "key_in_provider", "provider_id", "friendly_name", "submitted_usernames", "relationships", "access", "create_ts", "modify_ts"]

    @field_validator('access')
    def access_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['public', 'private']):
            raise ValueError("must be one of enum values ('public', 'private')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Data from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Data from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_id": obj.get("_id"),
            "key_in_provider": obj.get("key_in_provider"),
            "provider_id": obj.get("provider_id"),
            "friendly_name": obj.get("friendly_name"),
            "submitted_usernames": obj.get("submitted_usernames"),
            "relationships": obj.get("relationships"),
            "access": obj.get("access"),
            "create_ts": obj.get("create_ts"),
            "modify_ts": obj.get("modify_ts")
        })
        return _obj


